/*
 * 
 * @param {type} _Canvas
 * @returns {Loader}
 * 
 * Class Loader
 */

Loader = function(_Canvas){
    
    var canvas = _Canvas;
    var active = false;
    var level  = false;
    var menu   = false;
    
    var play = new Button(new Coordinate((canvas.width - BUTTON_WIDTH) / 2 ,
                                         (canvas.height - BUTTON_HEIGHT) / 2),
               new Dimension(BUTTON_WIDTH,BUTTON_HEIGHT),
               "Play");
               
    var easy = new Button(new Coordinate((canvas.width - BUTTON_WIDTH) / 2 ,
                                         (canvas.height - (2 * BUTTON_HEIGHT + BUTTON_INTERSPACE)) / 2),
                          new Dimension(BUTTON_WIDTH,BUTTON_HEIGHT),
                          "Easy");
                 
    var hard = new Button(new Coordinate((canvas.width - BUTTON_WIDTH) / 2 ,
                                         easy.getCoordinate().getY()+ BUTTON_HEIGHT + BUTTON_INTERSPACE),
                          new Dimension(BUTTON_WIDTH,BUTTON_HEIGHT),
                          "Hard");
                          
    var back_menu = new Button(new Coordinate((canvas.width - BUTTON_WIDTH) / 2 ,
                                         (canvas.height - BUTTON_HEIGHT) / 2),
                          new Dimension(BUTTON_WIDTH,BUTTON_HEIGHT),
                          "Menu");
    
    var width = Math.round(canvas.width * 0.90);
    var height = Math.round(canvas.height * 0.90);
    
    var x = (canvas.width - width) / 2;
    var y = (canvas.height - height) / 2;
    var coordinate = new Coordinate(x,y);
    var dimension = new Dimension(width, height);
     
    /* Get Set methods */
    this.getCanvas = function() { return canvas; };
    this.getCoordinate = function() { return coordinate; };
    this.getDimension = function() { return dimension; };
    this.isActive = function() { return active; };
    this.setActive = function(isActive) { active = isActive;};
    
    this.isLevel = function() { return level; };
    this.setLevel = function(isLevel) { level = isLevel;};
    this.isMenu = function() { return menu; };
    this.setMenu = function(isMenu) { menu = isMenu;};
    
    this.getPlayButton = function(){return play;};
    this.getEasyButton = function(){return easy;};
    this.getHardButton = function(){return hard;};
    this.getMenuButton = function(){return back_menu;};
   
    this.playVideo  = function(){ $('video').play(); };  
    
    this.drawPlayButton = function(){
        this.drawButton(new Array(play), IMG_INSTRUCTION);
    };
    
    this.drawDifficultButton = function(){
        this.drawButton(new Array(easy,hard));
    };
    
    this.drawLevelButton = function(){
        this.drawButton(new Array(back_menu));
    };
    
    this.drawButton = function(button, background){
    
        var context = canvas.getContext("2d");      
        var imageObj = new Image();
        if(!background)
            imageObj.src = IMG_BACKGROUND;        
        else 
            imageObj.src = background;
        imageObj.onload = function() {
        context.drawImage(imageObj, 0, 0, canvas.width, canvas.height);
        
        for (var i=0;i<button.length;i++){ 
        context.beginPath();    
        context.rect(button[i].getCoordinate().getX() ,
                     button[i].getCoordinate().getY(),
                     BUTTON_WIDTH,
                     BUTTON_HEIGHT);
        context.globalAlpha = 0.7;
        context.fillStyle = BUTTON_BACKGROUND_COLOR;
        context.fill();
        context.globalAlpha = 1;
        context.fillStyle = BUTTON_TEXT_COLOR;
        context.font      = BUTTON_FONT;
        context.fillText(button[i].getText(), 
                         button[i].getCoordinate().getX() + BUTTON_OFFSET_TEXT_X, 
                         button[i].getCoordinate().getY() + BUTTON_OFFSET_TEXT_Y);
        context.closePath();
        }
        
        };
    };
    
    this.showSlider =  function(){
        
        $('slider_container').style.display = "block";
    };
    
    this.hideSlider = function(){
        
        $('slider_container').style.display = "none";
    };
    
    this.slideElement = function(arrayLevel){
        
        this.showSlider();
        var conteiner = $('score');
        var html = '<h1>IMPORTANT!</h1>';
        html+='<p><b>1. Look at ingredients and memorize them!</b><br><br>';
        html+='<b>2. Then, choose them in the exact order in which they appeared!</b></p>';
        conteiner.innerHTML = html;
        this.rotate(false, 0, arrayLevel, this);         
    };
    
    this.rotate = function(MEMORIZE, thisAd, lev, t){
            var slider = $("slider_image");
                    
                    if ( !MEMORIZE && thisAd === 0 ){
                        slider.style.marginLeft="40px";
                        slider.src  = IMAGE_PATH + 'memorize' + IMAGE_EXT;
                        MEMORIZE = true;
                        setTimeout(function(){
                                    t.rotate(MEMORIZE, thisAd, lev, t)}
                                   , 4000);
                    }
                    else if (thisAd < lev.length) {
                        slider.src  = "";
                        slider.style.marginLeft="120px";
                        slider.src  = IMAGE_PATH + lev[thisAd] + IMAGE_EXT;
                        thisAd++;
                        setTimeout(function(){
                                    t.rotate(MEMORIZE, thisAd, lev, t)}
                                   , 2000);
                    }
                    else{
                        slider.src  = "";
                        slider.style.marginLeft="40px";
                        slider.src  = IMAGE_PATH + 'play' + IMAGE_EXT;
                        setTimeout(function(){
                            t.hideSlider();
                            Pizza.startPlayer();
                        },2500);
                    }
        };
};

document.addEventListener('DOMContentLoaded', function(){
    
	var v = $('video');
	var canvas = $('game_canvas');
	var context = canvas.getContext('2d');
 
	var cw = canvas.clientWidth;
	var ch = canvas.clientHeight;
	
	v.addEventListener('play', function(){
		draw(this,context,cw,ch);
	},false);
        
        v.addEventListener('ended',function() {
                Pizza.clearTimer();
                Pizza.clearCanvas();
                setTimeout(function(){
                    Pizza.showDifficulty();
                },500);
        },false);
 
},false);
 
function draw(v,c,w,h) {
	
	c.drawImage(v,0,0,w,h);
	Pizza.setTimer(setTimeout(draw,30,v,c,w,h));
}