
var LINEAR_SPEED = 1;
var POS = 0;
var ONE_SECOND = 1000;
var IMAGE_N = 7;
var CANVAS_H = ((IMAGE_N )*(IMAGE_HEIGHT + IMAGE_INTERSPACE_Y));





function shuffle(o){ //v1.0
    for(var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
    return o;
};

Player = function(_canvasArray){
    
    /*
     * ATTRIBUTE
     */
    var canvasArray = _canvasArray;
    var images = null;
    var currentLevel = null;
    var vendor = 
            (/webkit/i).test(navigator.appVersion) ? '-webkit' :
            (/firefox/i).test(navigator.userAgent) ? '-moz' :
            (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) ? '-ms' : '-ms';
            //'opera' in window ? '-o' : '';
    var cssTransform = vendor + '-transform'; 
    var offset_y = new Array(-CANVAS_H,
                             -CANVAS_H,
                             -CANVAS_H);
    
    this.setLevel = function(_level){ currentLevel = _level; };
    
    this.getLevel = function(){ return currentLevel;};
    
    /*
     * LOAD IMAGE
     */
    this.loadImage = function(){
       for( var j = 0; j < 3 ; j++){ 
            canvasArray[j].height = 2*IMAGE_N*(IMAGE_HEIGHT + IMAGE_INTERSPACE_Y);       
            canvasArray[j].setAttribute("style", cssTransform+":"+ 'translate3d(0px, '+ offset_y[j] +'px,0px)');
       }
       var newArray = shuffle(IMAGE);
       images = new Array(new Array(), new Array(), new Array());
       for( var j = 0; j < 2 ; j++) 
        for (var i = 0; i < IMAGE_N; i++) {
            images[0].push(new image(newArray[i]));
            images[1].push(new image(newArray[(i+4)%12]));
            images[2].push(new image(newArray[(i+8)%12]));
        } 
    };
    
    this.hitImages = function(_Coordinate, index){
        var y = _Coordinate.getY();
        y = Math.abs(offset_y[index])+y; 
        y = parseInt( y / ((IMAGE_HEIGHT + IMAGE_INTERSPACE_Y))) % IMAGE_N;
        var hit = currentLevel.checkIngredient(images[index][y].getName());
        if( hit ){
            if(!currentLevel.checkWin())
                this.loadImage();
            this.draw();
        }
        return hit;
    };
    /*
     * DRAW IMAGES ON CANVAS
     */
    this.draw = function(){
        var y = IMAGE_INTERSPACE_Y;
         
        for (var i = 0; i < images[0].length; i++) {
            images[0][i].draw(canvasArray[0], IMAGE_OFFSET_X, y);
            images[1][i].draw(canvasArray[1], IMAGE_OFFSET_X, y);
            images[2][i].draw(canvasArray[2], IMAGE_OFFSET_X, y);
            y+= IMAGE_HEIGHT + IMAGE_INTERSPACE_Y;
        }
    };
    
    this.loop = function(i) {  
        var newY = offset_y[canvasArray[i].tabIndex] + LINEAR_SPEED;
        if(newY >= 0) newY = -CANVAS_H;
        canvasArray[i].setAttribute("style", cssTransform+":"+ 'translate3d(0px, '+ newY +'px, 0px)');
        offset_y[canvasArray[i].tabIndex] = newY;
    };
};